'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var _require = require('child_process'),
    exec = _require.exec,
    spawn = _require.spawn;

var os = require('os');
var path = require('path');
var fs = require('fs');

module.exports = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee(opt) {
    var _opt, id, output, _opt$debug, debug, port, _opt$daemon, daemon, _opt$autoUpdate, autoUpdate, ver, procCmd;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            opt = opt || {};
            _opt = opt, id = _opt.id, output = _opt.output, _opt$debug = _opt.debug, debug = _opt$debug === undefined ? false : _opt$debug, port = _opt.port, _opt$daemon = _opt.daemon, daemon = _opt$daemon === undefined ? false : _opt$daemon, _opt$autoUpdate = _opt.autoUpdate, autoUpdate = _opt$autoUpdate === undefined ? true : _opt$autoUpdate;
            ver = fs.readFileSync(path.resolve(__dirname, '../.mongodal_ver'), 'utf8');
            procCmd = path.resolve(__dirname, `../bin/mongo-dal@${ver}`);
            _context.next = 6;
            return killProc(`mongo-dal`);

          case 6:
            _context.next = 8;
            return new Promise(function (resolve, reject) {
              function initResolveCb() {
                resolve();
                process.removeListener('SIGURG', initResolveCb);
              };
              process.on('SIGURG', initResolveCb).on('exit', clear(!daemon)).on('SIGINT', clear(!daemon)).on('SIGTERM', clear(!daemon));

              var args = ['-id', id];

              if (debug) {
                args.push('-d');
              }

              if (port != undefined) {
                port = port || 30017;
                args.push('-p', port);
              }

              var opts = undefined;
              if (daemon) {
                args.push('-D');
                opts = { detached: true };
                if (!output) {
                  args.push('-o', 'mongo-dal.log');
                }
              } else {
                if (typeof output === 'string' && output.length) {
                  args.push('-o', output);
                } else {
                  opts = { stdio: ['ignore', 'inherit', 'inherit'] };
                }
              }

              if (autoUpdate) {
                args.push('-u');
              }

              var subProcess = spawn(procCmd, args, opts);
              if (daemon) {
                subProcess.unref();
              }
            });

          case 8:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();

function killProc(name) {
  return new Promise(function (resolve, reject) {
    exec(`pgrep ${name}`, function (err, stdout, stderr) {
      if (err) {
        return resolve();
      }
      var pidsArg = stdout.replace(/\s/, ' ');

      exec(`kill ${pidsArg}`, function (err, stdout, stderr) {
        resolve(stdout);
      });
    });
  });
}

function _getEnv(opt) {
  var env = process.env.NODE_ENV || opt.env;

  switch (env) {
    case 'alpha':
    case 'alta':
    case 'altb':
    case 'prod':
      return env;
    case 'production':
      return 'prod';
    default:
      return 'alpha';
  }
}

function clear(needRemove) {
  return function () {
    if (needRemove) {
      var MONGODAL_PID = fs.readFileSync('/tmp/mongo_dal_pid', 'utf8');
      console.log("mongo_dal_pid: ", MONGODAL_PID);
      process.kill(Number(MONGODAL_PID), 'SIGTERM');
    }
    console.log('clear success');
    process.exit(0);
  };
}